pub mod md5 {
    use md5::Digest;
    pub fn hash<T: AsRef<[u8]>>(input: T) -> String {
        let mut hasher = md5::Md5::new();
        hasher.update(input);
        let result = hasher.finalize();
        crate::serialize::to_hex(result.as_slice())
    }
}

pub mod sha1 {
    use sha1::Digest;
    pub fn hash<T: AsRef<[u8]>>(input: T) -> String {
        let mut hasher = sha1::Sha1::new();
        hasher.update(input);
        let result = hasher.finalize();
        crate::serialize::to_hex(result.as_slice())
    }
}

pub mod sha512 {
    pub fn hash<T: AsRef<[u8]>>(input: T) -> String {
        let mut hasher = hmac_sha512::Hash::new();
        hasher.update(input);
        let result = hasher.finalize();
        crate::serialize::to_hex(result.as_slice())
    }
}
